ig.module( 
	'game.entities.player' 
)
.requires(
	'impact.entity'
)
.defines(function(){

	EntityPlayer = ig.Entity.extend({

		size : {
			x : 33,
			y : 36
		}, 

		collides: ig.Entity.COLLIDES.ACTIVE,
    	type: ig.Entity.TYPE.A,
    	checkAgainst: ig.Entity.TYPE.B,
			
		animSheet : new ig.AnimationSheet( 'media/chars_more.png', 32, 48 ),

		// own stuff
		speechBubble : null,


		init: function( x, y, settings ) {
			var animSpeed = 0.1;
			var animStop = false;
			this.addAnim('idleDown', 1, [49]);
			this.addAnim('idleRight', 1, [73]);
			this.addAnim('idleLeft', 1, [61]);
			this.addAnim('idleUp', 1, [85]);

			this.addAnim( 'moveDown', animSpeed, [48, 49, 50], animStop);
			this.addAnim( 'moveLeft', animSpeed, [60, 61, 62], animStop);
			this.addAnim( 'moveRight', animSpeed, [72, 73, 74], animStop);
			this.addAnim( 'moveUp', animSpeed, [84, 85, 86], animStop);
			this.parent(x,y,settings);
		},

		update: function() {

			var speed = 100;

			if(ig.input.state('move_right')) {
				this.currentAnim = this.anims.moveRight;
				this.vel.x = speed;
			}

			if(ig.input.state('move_left')) {
				this.currentAnim = this.anims.moveLeft;
				this.vel.x = -speed;
			}

			if(ig.input.state('move_down')) {
				this.currentAnim = this.anims.moveDown;
				this.vel.y = speed;
			}

			if(ig.input.state('move_up')) {
				this.currentAnim = this.anims.moveUp;
				this.vel.y = -speed;
			}

			if(ig.input.released('move_right')) {
				this.currentAnim = this.anims.idleRight;
				this.vel.x = 0;
				this.vel.y = 0;
			}

			if(ig.input.released('move_left')) {
				this.currentAnim = this.anims.idleLeft;
				this.vel.x = 0;
				this.vel.y = 0;
			}

			if(ig.input.released('move_down')) {
				this.currentAnim = this.anims.idleDown;
				this.vel.y = 0;
				this.vel.x = 0;
			}

			if(ig.input.released('move_up')) {
				this.currentAnim = this.anims.idleUp;
				this.vel.y = 0;
				this.vel.x = 0;	
			}
			this.currentAnim.update();

			if(ig.input.state( 'speak' )) {
				this.speak();
			}

			if(ig.input.state( 'stop-talking' )) {
				this.stopTalking();
			}

			this.parent();
		},

		speak: function() {
			if( this.speechBubble === null ) {
				// console.log("screen x: " + game.screen.x);
				console.log(ig.system.width);
				console.log(ig.game.screen.x);
				jQuery('#canvas').after("<div id='speechBubble'>  </div>");
				this.speechBubble = jQuery('#speechBubble');
				this.speechBubble.css({'background-color' : '#555', 'position' : 'absolute', 'top' : this.pos.y, 'left' : this.pos.x, 'font-size' : '14px', 'width' : '200px', 'height' : '30px' });
			}
		},

		stopTalking: function() {
			if(this.speechBubble !== null ) {
				this.speechBubble.remove();
				this.speechBubble = null;
			}
		}
	});

});