ig.module( 
	'game.main' 
)
.requires(
	'impact.game',
	'impact.font',
	'game.entities.player',
	'game.entities.star',
	'game.entities.planet', 
	'game.levels.main'

)
.defines(function(){

MyGame = ig.Game.extend({
	
	// Load a font
	font: new ig.Font( 'media/04b03.font.png' ),

	// own stuff
	// frameRate = 60;
	// screenWidth = 640; 
	// screenHeight = 480;
	
	
	init: function() {
		// Initialize your game here; bind keys etc.

		// move hero
		ig.input.bind( ig.KEY.D, 'move_right');
		ig.input.bind( ig.KEY.W, 'move_up');
		ig.input.bind( ig.KEY.S, 'move_down');
		ig.input.bind( ig.KEY.A, 'move_left');

		// talk with hero
		ig.input.bind( ig.KEY.E, 'speak');
		ig.input.bind( ig.KEY.Q, 'stop-talking');

		this.loadLevel( LevelMain );

		//must be defined after levelLoad - player undefined otherwise
		this.player = this.getEntitiesByType(EntityPlayer)[0];
		this.screenShaker = true;

		jQuery('#menu').append(this.buildMenu());
	},
	
	update: function() {
		// Update all entities and backgroundMaps
		this.parent();
		this.screenShake();
		// Add your own, additional update code here
	},
	
	draw: function() {
		// Draw all entities and backgroundMaps
		// console.log(this.player);
		this.parent();
		
		// Add your own drawing code here
		var x = ig.system.width/2,
			y = ig.system.height/2;
		
		// this.font.draw( 'Killing Spree', x, y, ig.Font.ALIGN.CENTER );
	},

	screenShake: function() {
		if(this.screenShaker) {
			if(this.screen.x > (this.player.pos.x - ig.system.width / 2) + 20 ) {
				this.screen.x -= 15;
			}else if(this.screen.x < (this.player.pos.x - ig.system.width / 2) - 20 ) {
				 this.screen.x += 15;
			}else{
				this.screen.x = this.player.pos.x - ig.system.width / 2;
			}

			if(this.screen.y > (this.player.pos.y - ig.system.height / 2) + 20 ) {
				this.screen.y -= 15;
			}else if(this.screen.y < (this.player.pos.y - ig.system.height / 2) - 20 ) {
				 this.screen.y += 15;
			}else{
				this.screen.y = this.player.pos.y - ig.system.height / 2;
			}
		}
	},

	buildMenu: function() {
		var menuStr = "";

		var menu = jQuery('#menu');
		var menuWidth = '200px';
		var menuHeight = '480px';

		menu.css({ 'width' : menuWidth, 'height' : menuHeight, 'background-color' : '#222', 'position' : 'absolute'});
		//id = #menu
		//pos of menu = window.screen.width / 2 - ig.system.width / 2 - menu.width; 
		menu.css({ 'left' : window.screen.width / 2 - ig.system.width / 2 - parseInt(menuWidth)});

		this.buildInventarArea(menuStr);
		console.log(menuStr);
		this.buildMiniMapArea(menuStr);
		this.buildChatArea(menuStr);
		return menuStr;
	},

	buildInventarArea: function(menuStr) {
		menuStr = menuStr + '<div id="inventarArea"> </div>';
		//style the area
		return menuStr;
	},

	buildMiniMapArea: function(menuStr) {

	},

	buildChatArea: function(menuStr) {

	}
});


// Start the Game with 60fps, a resolution of 320x240, scaled
// up by a factor of 2
ig.main( '#canvas', MyGame, 60, 640, 480, 1 );

});
